using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;

namespace ExcelTimesheet
{
	/// <summary>
	///   Add-in Express Add-in Module
	/// </summary>
	[GuidAttribute("B37BAE4C-93A9-440c-85EA-48F08B362499"), ProgId("ExcelTimeCard2005.AddinModule"), RunInstaller(true)]
	public class AddinModule : AddinExpress.MSO.ADXAddinModule
	{
		public AddinModule(System.ComponentModel.IContainer container)
		{
			container.Add(this);
			InitializeComponent();
		}

		private AddinExpress.MSO.ADXExcelAppEvents adxExcelEvents;

		private AddinExpress.MSO.ADXAddinAdditionalModuleItem adxAddinAdditionalModuleItem1;

		public AddinModule()
		{
			InitializeComponent();
		}

		#region Component Designer generated code
		/// <summary>
		/// Required by designer
		/// </summary>
		private System.ComponentModel.IContainer components;

		/// <summary>
		/// Required by designer support - do not modify
		/// the following method
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.adxAddinAdditionalModuleItem1 = new AddinExpress.MSO.ADXAddinAdditionalModuleItem(this.components);
			this.adxExcelEvents = new AddinExpress.MSO.ADXExcelAppEvents(this.components);
			// 
			// adxAddinAdditionalModuleItem1
			// 
			this.adxAddinAdditionalModuleItem1.ModuleProgID = "ExcelTimesheet2005.TimesheetModule";
			// 
			// adxExcelEvents
			// 
			this.adxExcelEvents.WindowActivate += new AddinExpress.MSO.ADXHostWindow_EventHandler(this.adxExcelEvents_WindowActivate);
			this.adxExcelEvents.WorkbookDeactivate += new AddinExpress.MSO.ADXHostActiveObject_EventHandler(this.adxExcelEvents_WorkbookDeactivate);
			// 
			// AddinModule
			// 
			this.AddinName = "Excel Timesheet Example";
			this.Modules.Add(this.adxAddinAdditionalModuleItem1);
			this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaExcel;
			this.AddinStartupComplete += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinStartupComplete);

		}
		#endregion

		#region ADX automatic code

		// Required by Add-in Express - do not modify
		// the methods within this region

		public override System.ComponentModel.IContainer GetContainer()
		{
			if (components == null)
				components = new System.ComponentModel.Container();
			return components;
		}

		[ComRegisterFunctionAttribute]
		public static void AddinRegister(Type t)
		{
			AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
		}

		[ComUnregisterFunctionAttribute]
		public static void AddinUnregister(Type t)
		{
			AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
		}

		public override void UninstallControls()
		{
			base.UninstallControls();
		}

		#endregion

		private void AddinModule_AddinStartupComplete(object sender, System.EventArgs e)
		{
			ChangeButtonState(false);
		}

		private void ChangeButtonState(bool enabled)
		{
			AddinExpress.MSO.ADXCommandBar cmdBar = CommandBarByName("Excel Timesheet Bar");
			if (cmdBar != null)
				cmdBar.Controls[0].Enabled = enabled;
		}

		private void adxExcelEvents_WorkbookDeactivate(object sender, object hostObj)
		{
			ChangeButtonState(false);
		}

		private void adxExcelEvents_WindowActivate(object sender, object hostObj, object window)
		{
			TimesheetModule myModule = Modules["TimesheetModule"].Module as TimesheetModule;
			if (myModule != null)
				myModule.OnWindowActivate(hostObj);
		}
	}
}
